Package ghidra.generic.util.datastruct

# Class TreeValueSortedMap.ValueSortedTreeMapValues

java.lang.Object
java.util.AbstractCollection<V>
ghidra.generic.util.datastruct.TreeValueSortedMap.ValueSortedTreeMapValues

All Implemented Interfaces:
  `SortedList<V>`, `ValueSortedMap.LesserList<V>`, `Iterable<V>`, `Collection<V>`

Enclosing class:
  `TreeValueSortedMap<K,V>`

protected class TreeValueSortedMap.ValueSortedTreeMapValues extends AbstractCollection<V> implements SortedList<V>
A public view of the map as a list of values This view implements `SortedList` and `Deque`, since an ordered collection ought to behave like a list, and since this implementation is meant to be used as a dynamic-cost priority queue. Generally, only the removal mutation methods are supported, all others are not supported.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `ceilingIndex(V element)`
  Returns the least index in this list whose element is greater than or equal to the specified element
  `void`
  `clear()`
  `boolean`
  `contains(Object o)`
  `int`
  `floorIndex(V element)`
  Returns the greatest index in this list whose element is less than or equal to the specified element
  `V`
  `get(int index)`
  Get the element at the given index
  `int`
  `higherIndex(V element)`
  Returns the least index in this list whose element is strictly greater the specified element
  `int`
  `indexOf(Object o)`
  Get the index of a given element
  `boolean`
  `isEmpty()`
  `Iterator<V>`
  `iterator()`
  `ListIterator<V>`
  `listIterator(int index)`
  `int`
  `lowerIndex(V element)`
  Returns the greatest index in this list whose element is strictly less than the specified element
  `V`
  `poll()`
  Get and remove the first element
  `boolean`
  `remove(Object o)`
  `int`
  `size()`
  `List<V>`
  `toList()`
  Copy this to a new list

  ### Methods inherited from class java.util.AbstractCollection

  `add, addAll, containsAll, removeAll, retainAll, toArray, toArray, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.util.Collection

  `equals, hashCode, parallelStream, removeIf, spliterator, stream, toArray`

  ### Methods inherited from interface java.lang.Iterable

  `forEach`

  ### Methods inherited from interface ghidra.generic.util.datastruct.ValueSortedMap.LesserList

  `removeAll`

- ## Method Details

  - ### toList

    public List<V> toList()
    Description copied from interface: `ValueSortedMap.LesserList`
    Copy this to a new list
    Specified by:
      `toList` in interface `ValueSortedMap.LesserList<V>`
    Returns:
      the list

  - ### clear

    public void clear()
    Specified by:
      `clear` in interface `Collection<V>`
    Overrides:
      `clear` in class `AbstractCollection<V>`

  - ### contains

    public boolean contains(Object o)
    Specified by:
      `contains` in interface `Collection<V>`
    Specified by:
      `contains` in interface `ValueSortedMap.LesserList<V>`
    Overrides:
      `contains` in class `AbstractCollection<V>`

  - ### get

    public V get(int index)
    Description copied from interface: `ValueSortedMap.LesserList`
    Get the element at the given index
    Specified by:
      `get` in interface `ValueSortedMap.LesserList<V>`
    Parameters:
      `index` - the index
    Returns:
      the element

  - ### indexOf

    public int indexOf(Object o)
    Description copied from interface: `ValueSortedMap.LesserList`
    Get the index of a given element

    Returns the index of the element, or -1 if not found

    Specified by:
      `indexOf` in interface `ValueSortedMap.LesserList<V>`
    Parameters:
      `o` - the object
    Returns:
      the index or -1

  - ### lowerIndex

    public int lowerIndex(V element)
    Description copied from interface: `SortedList`
    Returns the greatest index in this list whose element is strictly less than the specified element
    Specified by:
      `lowerIndex` in interface `SortedList<V>`
    Parameters:
      `element` - the element to search for
    Returns:
      the index of the found element, or -1

  - ### floorIndex

    public int floorIndex(V element)
    Description copied from interface: `SortedList`
    Returns the greatest index in this list whose element is less than or equal to the specified element

    If multiples of the specified element exist, this returns the least index of that element.

    Specified by:
      `floorIndex` in interface `SortedList<V>`
    Parameters:
      `element` - the element to search for
    Returns:
      the index of the found element, or -1

  - ### ceilingIndex

    public int ceilingIndex(V element)
    Description copied from interface: `SortedList`
    Returns the least index in this list whose element is greater than or equal to the specified element

    If multiples of the specified element exist, this returns the greatest index of that element.

    Specified by:
      `ceilingIndex` in interface `SortedList<V>`
    Parameters:
      `element` - the element to search for
    Returns:
      the index of the found element, or -1

  - ### higherIndex

    public int higherIndex(V element)
    Description copied from interface: `SortedList`
    Returns the least index in this list whose element is strictly greater the specified element
    Specified by:
      `higherIndex` in interface `SortedList<V>`
    Parameters:
      `element` - the element to search for
    Returns:
      the index of the found element, or -1

  - ### isEmpty

    public boolean isEmpty()
    Specified by:
      `isEmpty` in interface `Collection<V>`
    Specified by:
      `isEmpty` in interface `ValueSortedMap.LesserList<V>`
    Overrides:
      `isEmpty` in class `AbstractCollection<V>`

  - ### listIterator

    public ListIterator<V> listIterator(int index)
    Specified by:
      `listIterator` in interface `ValueSortedMap.LesserList<V>`

  - ### iterator

    public Iterator<V> iterator()
    Specified by:
      `iterator` in interface `Collection<V>`
    Specified by:
      `iterator` in interface `Iterable<V>`
    Specified by:
      `iterator` in class `AbstractCollection<V>`

  - ### poll

    public V poll()
    Description copied from interface: `ValueSortedMap.LesserList`
    Get and remove the first element
    Specified by:
      `poll` in interface `ValueSortedMap.LesserList<V>`
    Returns:
      the first element, or null if empty

  - ### remove

    public boolean remove(Object o)
    Specified by:
      `remove` in interface `Collection<V>`
    Specified by:
      `remove` in interface `ValueSortedMap.LesserList<V>`
    Overrides:
      `remove` in class `AbstractCollection<V>`

  - ### size

    public int size()
    Specified by:
      `size` in interface `Collection<V>`
    Specified by:
      `size` in interface `ValueSortedMap.LesserList<V>`
    Specified by:
      `size` in class `AbstractCollection<V>`